//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// DefaultTrigger is used by the mission editor.  This is also an example
// of trigger methods and callbacks.

datablock TriggerData(DefaultTrigger)
{
   // The period is value is used to control how often the console
   // onTriggerTick callback is called while there are any objects
   // in the trigger.  The default value is 100 MS.
   tickPeriodMS = 100;
};


//-----------------------------------------------------------------------------

function DefaultTrigger::onEnterTrigger(%this,%trigger,%obj)
{
   // This method is called whenever an object enters the %trigger
   // area, the object is passed as %obj.  The default onEnterTrigger
   // method (in the C++ code) invokes the ::onTrigger(%trigger,1) method on
   // every object (whatever it's type) in the same group as the trigger.
   Parent::onEnterTrigger(%this,%trigger,%obj);
}

function DefaultTrigger::onLeaveTrigger(%this,%trigger,%obj)
{
   // This method is called whenever an object leaves the %trigger
   // area, the object is passed as %obj.  The default onLeaveTrigger
   // method (in the C++ code) invokes the ::onTrigger(%trigger,0) method on
   // every object (whatever it's type) in the same group as the trigger.
   Parent::onLeaveTrigger(%this,%trigger,%obj);
}

function DefaultTrigger::onTickTrigger(%this,%trigger)
{
   // This method is called every tickPerioMS, as long as any
   // objects intersect the trigger. The default onTriggerTick
   // method (in the C++ code) invokes the ::onTriggerTick(%trigger) method on
   // every object (whatever it's type) in the same group as the trigger.

   // You can iterate through the objects in the list by using these
   // methods:
   //    %this.getNumObjects();
   //    %this.getObject(n);
   Parent::onTickTrigger(%this,%trigger);
}

/** Begin King of the Hill Trigger **/
datablock TriggerData(kingofthehillTrigger)
{
  tickPeriodMS = 1000; 
  //set to 1000 so it ticks every second
};
function kingofthehillTrigger::onEnterTrigger(%this,%trigger,%obj)
{ 
   $kingofthehill = %obj.client;
   %obj.client.incScore(1);
   messageAll('MsgClienthill','\c2 %1 is King of the Hill.',%obj.client.name); 
   //states that a person entered the hill
    $KingsoftheHill++; //adds 1 to the variable that will count
// how many people are in the hill
   if (%obj.client.score >= $Game::EndGameScore) 
   //checks to see if the max score has been reched
   cycleGame(); 
  //restarts game if score has been reached
 }
function kingofthehillTrigger::onLeaveTrigger(%this,%trigger,%obj)
{
  %client = $kingofthehill;
  %client.incScore(0); 
  messageAll('MsgClienthill','\c2 %1 has left the Hill.',%obj.client.name);
  $KingsoftheHill--; //Lowers the variable by 1
  //states that a person has left the hill
  }
function kingofthehillTrigger::onTickTrigger(%this,%trigger,%obj)
{
 if ($KingsoftheHill $= 1) { //Makes sure that there is only 1 person on the hill
  %client = $kingofthehill;
  %client.incScore(1);
//gives the person on the hill one point everytime the trigger ticks if there is 
//only 1 person on the hill
}
}  
datablock TriggerData(newgameTrigger)
{
  tickPeriodMS = 1000;
};
function newgameTrigger::onEnterTrigger(%this,%trigger,%obj)
{ 
  $kingofthehill = %obj.client;
  %obj.client.setScore(0);
  //resets the score to Start a new game of KOTH
}
function newgameTrigger::onLeaveTrigger(%this,%trigger,%obj)
{
  %client = $kingofthehill;
  %client.setScore(0);
}
function newgameTrigger::onTickTrigger(%this,%trigger,%obj)
{
}
/** END King of the Hill Trigger **/