//-----------------------------------------------------------------------------
// Torque Content Pack
// Copyright (C) 2003 GameBeavers.org
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// tnt. This file contains all the items related to this weapon
// including explosions, ammo, the item and the weapon item image.
// These objects rely on the item & inventory support system defined
// in item.cs and inventory.cs
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Sounds
datablock AudioProfile(tntFireSound)
{
   filename = "~/data/sound/tnttoss.wav";
   description = AudioClose3d;
   preload = false;
};

datablock AudioProfile(tntEmpty)
{
   filename    = "~/data/sound/weapons/m13_noammo.wav";
   description = AudioClosest3d;
   preload = false;
};

datablock AudioProfile(tntReload)
{
   filename    = "~/data/sound/weapons/m13_reload.wav";
   description = AudioClosest3d;
   preload = false;
};

datablock AudioProfile(tntActivate)
{
   filename    = "~/data/sound/weapons/m13_switch.wav";
   description = AudioClosest3d;
   preload = false;
};

datablock AudioProfile(tntExplosionSound)
{
filename = "~/data/sound/tntexplode.wav";
description = AudioDefault3d;
preload = false;
};

//------------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// grenade bolt projectile splash

datablock ParticleData(tntSplashMist)
{
   dragCoefficient      = 2.0;
   gravityCoefficient   = -0.05;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 400;
   lifetimeVarianceMS   = 100;
   useInvAlpha          = false;
   spinRandomMin        = -90.0;
   spinRandomMax        = 500.0;
   textureName          = "~/data/shapes/textures/weapons/crossbow/splash";

   colors[0]     = "0.7 0.8 1.0 1.0";
   colors[1]     = "0.7 0.8 1.0 0.5";
   colors[2]     = "0.7 0.8 1.0 0.0";

   sizes[0]      = 0.5;
   sizes[1]      = 0.5;
   sizes[2]      = 0.8;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(tntSplashMistEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 3.0;
   velocityVariance = 2.0;
   ejectionOffset   = 0.0;
   thetaMin         = 85;
   thetaMax         = 85;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   lifetimeMS       = 250;
   particles = "tntSplashMist";
};

datablock ParticleData( tntSplashParticle )
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 0;
   colors[0]     = "0.7 0.8 1.0 1.0";
   colors[1]     = "0.7 0.8 1.0 0.5";
   colors[2]     = "0.7 0.8 1.0 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.5;
   sizes[2]      = 0.5;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( tntSplashEmitter )
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 60;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   orientParticles  = true;
   lifetimeMS       = 100;
   particles = "tntSplashParticle";
};

datablock SplashData(tntSplash)
{
   numSegments = 15;
   ejectionFreq = 15;
   ejectionAngle = 40;
   ringLifetime = 0.5;
   lifetimeMS = 300;
   velocity = 4.0;
   startRadius = 0.0;
   acceleration = -3.0;
   texWrap = 5.0;

   texture = "~/data/shapes/textures/weapons/crossbow/splash";

   emitter[0] = tntSplashEmitter;
   emitter[1] = tntSplashMistEmitter;

   colors[0] = "0.7 0.8 1.0 0.0";
   colors[1] = "0.7 0.8 1.0 0.3";
   colors[2] = "0.7 0.8 1.0 0.7";
   colors[3] = "0.7 0.8 1.0 0.0";
   times[0] = 0.0;
   times[1] = 0.4;
   times[2] = 0.8;
   times[3] = 1.0;
};

//-----------------------------------------------------------------------------
// grenade bolt projectile particles

//datablock ParticleData(grenadeBoltParticle)
//{
//   textureName          = "~/data/shapes/particles/smoke";
//   dragCoefficient     = 0.0;
//   gravityCoefficient   = -0.1;   // rises slowly
//   inheritedVelFactor   = 0.0;
//   lifetimeMS           = 150;
//   lifetimeVarianceMS   = 10;   // ...more or less
//   useInvAlpha = false;
//   spinRandomMin = -30.0;
//   spinRandomMax = 30.0;

//   colors[0]     = "0.1 0.1 0.1 1.0";
//   colors[1]     = "0.1 0.1 0.1 1.0";
//   colors[2]     = "0.1 0.1 0.1 0";

//   sizes[0]      = 0.15;
//   sizes[1]      = 0.20;
//   sizes[2]      = 0.25;

//   times[0]      = 0.0;
//   times[1]      = 0.3;
//   times[2]      = 1.0;
//};

datablock ParticleData(tntBubbleParticle)
{
   textureName          = "~/data/shapes/textures/particles/bubble";
   dragCoefficient      = 0.0;
   gravityCoefficient   = -0.25;   // rises slowly
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 1500;
   lifetimeVarianceMS   = 600;    // ...more or less
   useInvAlpha          = false;
   spinRandomMin        = -100.0;
   spinRandomMax        = 100.0;

   colors[0]     = "0.7 0.8 1.0 0.4";
   colors[1]     = "0.7 0.8 1.0 1.0";
   colors[2]     = "0.7 0.8 1.0 0.0";

   sizes[0]      = 0.2;
   sizes[1]      = 0.2;
   sizes[2]      = 0.2;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

//datablock ParticleEmitterData(grenadeBoltEmitter)
//{
//   ejectionPeriodMS = 2;
//   periodVarianceMS = 0;

//   ejectionVelocity = 0.2;
//   velocityVariance = 0.10;

//   thetaMin         = 0.0;
//   thetaMax         = 90.0;

//   particles = grenadeBoltParticle;
//};

datablock ParticleEmitterData(tntBoltBubbleEmitter)
{
   ejectionPeriodMS = 9;
   periodVarianceMS = 0;

   ejectionVelocity = 1.0;
   ejectionOffset   = 0.1;
   velocityVariance = 0.5;

   thetaMin         = 0.0;
   thetaMax         = 80.0;

   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;

   particles = tntBubbleParticle;
};


//-----------------------------------------------------------------------------
// Explosion Debris

// Debris "spark" explosion
datablock ParticleData(tntDebrisSpark)
{
   textureName          = "~/data/shapes/textures/particles/fire";
   dragCoefficient      = 0;
   gravityCoefficient   = 0.0;
   windCoefficient      = 0;
   inheritedVelFactor   = 0.5;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 50;
   spinRandomMin = -90.0;
   spinRandomMax =  90.0;
   useInvAlpha   = false;

   colors[0]     = "0.8 0.2 0 1.0";
   colors[1]     = "0.8 0.2 0 1.0";
   colors[2]     = "0 0 0 0.0";

   sizes[0]      = 0.2;
   sizes[1]      = 0.3;
   sizes[2]      = 0.1;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(tntDebrisSparkEmitter)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 0;
   ejectionVelocity = 0.5;
   velocityVariance = 0.25;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = false;
   lifetimeMS       = 300;
   particles = "tntDebrisSpark";
};

datablock ExplosionData(tntDebrisExplosion)
{
   emitter[0] = tntDebrisSparkEmitter;

   // Turned off..
   shakeCamera = false;
   impulseRadius = 0;
   lightStartRadius = 0;
   lightEndRadius = 0;
};

// Debris smoke trail
//datablock ParticleData(grenadeDebrisTrail)
//{
//   textureName          = "~/data/shapes/particles/fire";
//   dragCoefficient      = 1;
//   gravityCoefficient   = 0;
//   inheritedVelFactor   = 0;
//   windCoefficient      = 0;
//   constantAcceleration = 0;
//   lifetimeMS           = 800;
//   lifetimeVarianceMS   = 100;
//   spinSpeed     = 0;
//   spinRandomMin = -90.0;
//   spinRandomMax =  90.0;
//   useInvAlpha   = true;
//
//   colors[0]     = "0.8 0.3 0.0 1.0";
//   colors[1]     = "0.1 0.1 0.1 0.7";
//   colors[2]     = "0.1 0.1 0.1 0.0";

//   sizes[0]      = 0.2;
//   sizes[1]      = 0.3;
//   sizes[2]      = 0.4;

//   times[0]      = 0.1;
//   times[1]      = 0.2;
//   times[2]      = 1.0;
//};

//datablock ParticleEmitterData(grenadeDebrisTrailEmitter)
//{
//   ejectionPeriodMS = 30;
//   periodVarianceMS = 0;
//   ejectionVelocity = 0.0;
//   velocityVariance = 0.0;
//   ejectionOffset   = 0.0;
//   thetaMin         = 170;
//   thetaMax         = 180;
//   phiReferenceVel  = 0;
//   phiVariance      = 360;
//   //overrideAdvances = false;
   //orientParticles  = true;
//   lifetimeMS       = 5000;
//   particles = "grenadeDebrisTrail";
//};

// Debris object
datablock DebrisData(tntExplosionDebris)
{
   shapeFile = "~/data/shapes/textures/weapons/crossbow/debris.dts";
  // emitters = "tntDebrisTrailEmitter";
   explosion = tntDebrisExplosion;

   elasticity = 0.6;
   friction = 0.5;
   numBounces = 1;
   bounceVariance = 1;
   explodeOnMaxBounce = true;
   staticOnMaxBounce = false;
   snapOnMaxBounce = false;
   minSpinSpeed = 0;
   maxSpinSpeed = 700;
   render2D = false;
   lifetime = 4;
   lifetimeVariance = 0.4;
   velocity = 5;
   velocityVariance = 0.5;
   fade = false;
   useRadiusMass = true;
   baseRadius = 0.3;
   gravModifier = 0.5;
   terminalVelocity = 6;
   ignoreWater = true;
};


//-----------------------------------------------------------------------------
// Bolt Explosion

datablock ParticleData(tntExplosionSmoke)
{
   textureName          = "~/data/shapes/textures/particles/smoke";
   dragCoeffiecient     = 100.0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.25;
   constantAcceleration = -0.30;
   lifetimeMS           = 1200;
   lifetimeVarianceMS   = 300;
   useInvAlpha =  true;
   spinRandomMin = -80.0;
   spinRandomMax =  80.0;

   colors[0]     = "0.56 0.36 0.26 1.0";
   colors[1]     = "0.2 0.2 0.2 1.0";
   colors[2]     = "0.0 0.0 0.0 0.0";

   sizes[0]      = 1.0;
   sizes[1]      = 3.0;
   sizes[2]      = 4.0;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleData(tntExplosionBubble)
{
   textureName          = "~/data/shapes/textures/particles/bubble";
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -0.25;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 1500;
   lifetimeVarianceMS   = 600;
   useInvAlpha          = false;
   spinRandomMin        = -100.0;
   spinRandomMax        =  100.0;

   colors[0]     = "0.7 0.8 1.0 0.4";
   colors[1]     = "0.7 0.8 1.0 0.4";
   colors[2]     = "0.7 0.8 1.0 0.0";

   sizes[0]      = 0.3;
   sizes[1]      = 0.3;
   sizes[2]      = 0.3;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(tntExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 4;
   velocityVariance = 0.5;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   lifetimeMS       = 250;
   particles = "tntExplosionSmoke";
};

datablock ParticleEmitterData(tntExplosionBubbleEmitter)
{
   ejectionPeriodMS = 9;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   ejectionOffset   = 0.1;
   velocityVariance = 0.5;
   thetaMin         = 0.0;
   thetaMax         = 80.0;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "tntExplosionBubble";
};

datablock ParticleData(tntExplosionFire)
{
   textureName          = "~/data/shapes/textures/particles/fire";
   dragCoeffiecient     = 100.0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.25;
   constantAcceleration = 0.1;
   lifetimeMS           = 1200;
   lifetimeVarianceMS   = 300;
   useInvAlpha =  false;
   spinRandomMin = -80.0;
   spinRandomMax =  80.0;

   colors[0]     = "0.8 0.4 0 0.8";
   colors[1]     = "0.2 0.0 0 0.8";
   colors[2]     = "0.0 0.0 0.0 0.0";

   sizes[0]      = 1.5;
   sizes[1]      = 2;
   sizes[2]      = 3;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(tntExplosionFireEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 0.8;
   velocityVariance = 0.5;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   lifetimeMS       = 250;
   particles = "tntExplosionFire";
};

datablock ParticleData(tntExplosionSparks)
{
   textureName          = "~/data/shapes/textures/particles/spark";
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 350;

   colors[0]     = "0.60 0.40 0.30 1.0";
   colors[1]     = "0.60 0.40 0.30 1.0";
   colors[2]     = "1.0 0.40 0.30 0.0";

   sizes[0]      = 0.25;
   sizes[1]      = 0.15;
   sizes[2]      = 0.15;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleData(tntExplosionWaterSparks)
{
   textureName          = "~/data/shapes/textures/particles/bubble";
   dragCoefficient      = 0;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 350;

   colors[0]     = "0.4 0.4 1.0 1.0";
   colors[1]     = "0.4 0.4 1.0 1.0";
   colors[2]     = "0.4 0.4 1.0 0.0";

   sizes[0]      = 0.5;
   sizes[1]      = 0.5;
   sizes[2]      = 0.5;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(tntExplosionSparkEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 100;
   particles = "tntExplosionSparks";
};

datablock ParticleEmitterData(tntExplosionWaterSparkEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 4;
   velocityVariance = 4;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "tntExplosionWaterSparks";
};

datablock ExplosionData(tntSubExplosion1)
{
   offset = 0;
   emitter[0] = tntExplosionSmokeEmitter;
   emitter[1] = tntExplosionSparkEmitter;
};

datablock ExplosionData(tntSubExplosion2)
{
   offset = 0.3;
   emitter[0] = tntExplosionSmokeEmitter;
   emitter[1] = tntExplosionSparkEmitter;
};

datablock ExplosionData(tntSubWaterExplosion1)
{
   delayMS   = 100;
   offset    = 1.2;
   playSpeed = 1.5;

   emitter[0] = tntExplosionBubbleEmitter;
   emitter[1] = tntExplosionWaterSparkEmitter;

   sizes[0] = "0.75 0.75 0.75";
   sizes[1] = "1.0 1.0 1.0";
   sizes[2] = "0.5 0.5 0.5";
   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;
};

datablock ExplosionData(tntSubWaterExplosion2)
{
   delayMS   = 50;
   offset    = 1.2;
   playSpeed = 0.75;

   emitter[0] = tntExplosionBubbleEmitter;
   emitter[1] = tntExplosionWaterSparkEmitter;

   sizes[0] = "1.5 1.5 1.5";
   sizes[1] = "1.5 1.5 1.5";
   sizes[2] = "1.0 1.0 1.0";
   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;
};

datablock ExplosionData(tntExplosion)
{
   soundProfile = tntExplosionSound;
   lifeTimeMS = 1200;

   // Volume particles
   particleEmitter = tntExplosionFireEmitter;
   particleDensity = 200;
   particleRadius = 8;

   // Point emission
   //emitter[0] = grenadeExplosionSmokeEmitter;
   //emitter[1] = grenadeExplosionSparkEmitter;

   // Sub explosion objects
   subExplosion[0] = tntSubExplosion1;
   subExplosion[1] = tntSubExplosion2;

   // Camera Shaking
   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Exploding debris
   debris = tntExplosionDebris;
   debrisThetaMin = 0;
   debrisThetaMax = 60;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisNum = 6;
   debrisNumVariance = 5;
   debrisVelocity = 0.6;
   debrisVelocityVariance = 0.4;

   // Impulse
   impulseRadius = 10;
   impulseForce = 20;

   // Dynamic light
   lightStartRadius = 6;
   lightEndRadius = 3;
   lightStartColor = "0.5 0.5 0";
   lightEndColor = "0 0 0";
};

datablock ExplosionData(tntWaterExplosion)
{
   soundProfile = tntExplosionSound;

   // Volume particles
   particleEmitter = tntExplosionBubbleEmitter;
   particleDensity = 375;
   particleRadius = 7;


   // Point emission
   emitter[0] = tntExplosionBubbleEmitter;
   emitter[1] = tntExplosionWaterSparkEmitter;

   // Sub explosion objects
   subExplosion[0] = tntSubWaterExplosion1;
   subExplosion[1] = tntSubWaterExplosion2;

   // Camera Shaking
   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "3.0 3.0 3.0";
   camShakeDuration = 1.3;
   camShakeRadius = 10.0;

   // Exploding debris
   debris = tntExplosionDebris;
   debrisThetaMin = 0;
   debrisThetaMax = 60;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisNum = 7;
   debrisNumVariance = 5;
   debrisVelocity = 0.8;
   debrisVelocityVariance = 0.4;

   // Impulse
   impulseRadius = 10;
   impulseForce = 45;

   // Dynamic light
   lightStartRadius = 6;
   lightEndRadius = 3;
   lightStartColor = "0 0.5 0.5";
   lightEndColor = "0 0 0";
};


//-----------------------------------------------------------------------------
// Projectile Object

datablock ProjectileData(tntProjectile)
{
   projectileShapeName = "~/data/shapes/textures/weapons/tnt/tntProjectile.dts";
   directDamage        = 105;
   radiusDamage        = 50;
   damageRadius        = 20;
   areaImpulse         = 50;
   
   explosion           = tntExplosion;
   //particleEmitter     = m13SmokeEmitter;

   muzzleVelocity      = 20;
   velInheritFactor    = 1.0;
   
   explodeOnExplodeTime = true; // boolean value [true if you want it to blow on expiration of explode time
   explosiontime = 4000; // time that passes before explosion happens barring having a collision first.

   armingDelay         = 3000;
   lifetime            = 5000;
   fadeDelay           = 2500;
   bounceElasticity    = 0.75;
   bounceFriction      = 0.3;
   isBallistic         = true;
   gravityMod = 0.9;
   scale = "1.0 1.0 1.0";

   hasLight    = false;
   lightRadius = 1.0;
   lightColor  = "0 1 0";
};

function tntProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
   // Apply damage to the object all shape base objects
   if (%col.getType() & $TypeMasks::ShapeBaseObjectType)
      %col.damage(%obj,%pos,%this.directDamage,"m13Bullet");

   // Radius damage is a support scripts defined in radiusDamage.cs
   // Push the contact point away from the contact surface slightly
   // along the contact normal to derive the explosion center. -dbs
      radiusDamage(%obj, VectorAdd(%pos, VectorScale(%normal, 0.01)),
      %this.damageRadius,%this.radiusDamage,"Radius",10);
}


//-----------------------------------------------------------------------------
// Ammo Item

datablock ItemData(tntAmmo)
{
   // Mission editor category
   category = "Ammo";

   // Add the Ammo namespace as a parent.  The ammo namespace provides
   // common ammo related functions and hooks into the inventory system.
   className = "Ammo";

   // Basic Item properties
   shapeFile = "~/data/shapes/textures/weapons/tnt/tntProjectile.dts";
   mass = 60;
   elasticity = 0.9;
   friction = 1.0;

	// Dynamic properties defined by the scripts
	pickUpName = "more dynomite";
   maxInventory = 12;
};

//--------------------------------------------------------------------------
// Weapon Item.  This is the item that exists in the world, i.e. when it's
// been dropped, thrown or is acting as re-spawnable item.  When the weapon
// is mounted onto a shape, the m13Image is used.

datablock ItemData(tnt)
{
   // Mission editor category
   category = "Weapon";

   // Hook into Item Weapon class hierarchy. The weapon namespace
   // provides common weapon handling functions in addition to hooks
   // into the inventory system.
   className = "Weapon";

   // Basic Item properties
   shapeFile = "~/data/shapes/textures/weapons/tnt/tnt.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;

	// Dynamic properties defined by the scripts
	pickUpName = "Dynomite";
	image = tntImage;
};


//--------------------------------------------------------------------------
// m13 image which does all the work.  Images do not normally exist in
// the world, they can only be mounted on ShapeBase objects.

datablock ShapeBaseImageData(tntImage)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/textures/weapons/tnt/tnt.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.22 0.45 -0.25";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = tnt;
   ammo = tntAmmo;
   projectile = tntProjectile;
   projectileType = Projectile;


   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";

   // Activating the gun.  Called when the weapon is first
   // mounted and there is ammo.
   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.5;
   stateSequence[1]                 = "Activate";
  // stateSound[1]                    = tntActivate;

   // Ready to fire, just waiting for the trigger
   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   //stateSequence[2]                 = "bob";
   stateTransitionOnTriggerDown[2]  = "Fire";



   // Fire the weapon. Calls the fire script which does
   // the actual work.
   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.8;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";
  // stateEmitter[3]                  = tntFireEmitter;
   stateEmitterTime[3]              = 0.3;
   //stateSound[3]                    = tntFire;


   // Play the relead animation, and transition into
   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.1;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateEjectShell[4]               = true;


   // No ammo in the weapon, just idle until something
   // shows up. Play the dry fire sound if the trigger is
   // pulled.
   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "bob";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   // No ammo dry fire
   stateName[6]                     = "DryFire";
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "NoAmmo";
   stateSequence[6]                 = "Reload";
  // stateSound[6]                    = tntEmpty;
};


//-----------------------------------------------------------------------------

function tntImage::onFire(%this, %obj, %slot)
{
   %projectile = %this.projectile;

   // Decrement inventory ammo. The image's ammo state is update
   // automatically by the ammo inventory hooks.
   %obj.decInventory(%this.ammo,1);
   serverPlay3D(tntFireSound,%obj.getTransform());
   %currentAmmo = %obj.getInventory(%this.ammo);
   %obj.client.setAmmoAmountHud(%currentAmmo);
   // Determin initial projectile velocity based on the
   // gun's muzzle point and the object's current velocity
   %muzzleVector = %obj.getMuzzleVector(%slot);
   %objectVelocity = %obj.getVelocity();
   %muzzleVelocity = VectorAdd(
      VectorScale(%muzzleVector, %projectile.muzzleVelocity),
      VectorScale(%objectVelocity, %projectile.velInheritFactor));

   // Create the projectile object
   %p = new (%this.projectileType)() {
      dataBlock        = %projectile;
      initialVelocity  = %muzzleVelocity;
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
      client           = %obj.client;
   };
   MissionCleanup.add(%p);
   return %p;
}
